﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Interactivity;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using System.Linq;

namespace HorisontalScollIntoView
{
	public class ScrollBehavior : Behavior<RadGridView>
	{
		public static DependencyProperty FirstVisibleColumnIndexProperty = DependencyProperty.Register("FirstVisibleColumn", typeof(int), typeof(ScrollBehavior), new PropertyMetadata(0));

		public int FirstVisibleColumnIndex
		{
			get
			{
				return (int)this.GetValue(ScrollBehavior.FirstVisibleColumnIndexProperty);
			}
			set
			{
				this.SetValue(ScrollBehavior.FirstVisibleColumnIndexProperty, value);
			}
		}

		protected override void OnAttached()
		{
			base.OnAttached();
		//	this.AssociatedObject.AutoGeneratingColumn += new EventHandler<GridViewAutoGeneratingColumnEventArgs>(AssociatedObject_AutoGeneratingColumn);
			this.AssociatedObject.DataLoaded += new EventHandler<EventArgs>(AssociatedObject_DataLoaded);

		}

		//void AssociatedObject_AutoGeneratingColumn(object sender, GridViewAutoGeneratingColumnEventArgs e)
		//{
		//    e.Column.Width = new GridViewLength(200, GridViewLengthUnitType.Pixel);
		//}

		void AssociatedObject_DataLoaded(object sender, EventArgs e)
		{
			GridViewScrollViewer scroll = this.AssociatedObject.ChildrenOfType<GridViewScrollViewer>().First();
			scroll.ScrollToHorizontalOffset(200 * FirstVisibleColumnIndex);
		}
	}
}
